Regular Expressions
Collaboration diagram for Regular Expressions:

## Modules

| Base and Implementation Classes

## Namespaces

namespace | std::regex_constants

## Classes

class | std::basic_regex< _Ch_type, _Rx_traits >
class | std::match_results< _Bi_iter, _Alloc >
class | std::regex_error
class | std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >
class | std::regex_token_iterator< _Bi_iter, _Ch_type, _Rx_traits >
struct | std::regex_traits< _Ch_type >
class | std::sub_match< _BiIter >

## Typedefs

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
using | std::__sub_match_string = basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc >
typedef match_results< const char * > | std::cmatch
typedef regex_iterator< const char * > | std::cregex_iterator
typedef regex_token_iterator < const char * > | std::cregex_token_iterator
typedef sub_match< const char * > | std::csub_match
typedef basic_regex< char > | std::regex
typedef match_results < string::const_iterator > | std::smatch
typedef regex_iterator < string::const_iterator > | std::sregex_iterator
typedef regex_token_iterator < string::const_iterator > | std::sregex_token_iterator
typedef sub_match < string::const_iterator > | std::ssub_match
typedef match_results< const wchar_t * > | std::wcmatch
typedef regex_iterator< const wchar_t * > | std::wcregex_iterator
typedef regex_token_iterator < const wchar_t * > | std::wcregex_token_iterator
typedef sub_match< const wchar_t * > | std::wcsub_match
typedef basic_regex< wchar_t > | std::wregex
typedef match_results < wstring::const_iterator > | std::wsmatch
typedef regex_iterator < wstring::const_iterator > | std::wsregex_iterator
typedef regex_token_iterator < wstring::const_iterator > | std::wsregex_token_iterator
typedef sub_match < wstring::const_iterator > | std::wssub_match

## Functions

template<typename _Bi_iter >
const sub_match< _Bi_iter > & | std::__unmatched_sub ()
bool | std::regex_traits< _Ch_type >::isctype (_Ch_type __c, char_class_type __f) const
template<typename _BiIter >
bool | std::operator!= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator!= (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator!= (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator!= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator!= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator!= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator!= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Bi_iter , class _Alloc >
bool | std::operator!= (const match_results< _Bi_iter, _Alloc > &__m1, const match_results< _Bi_iter, _Alloc > &__m2)
template<typename _BiIter >
bool | std::operator< (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator< (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator< (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator< (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator< (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator< (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator< (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Ch_type , typename _Ch_traits , typename _Bi_iter >
basic_ostream< _Ch_type, _Ch_traits > & | std::operator<< (basic_ostream< _Ch_type, _Ch_traits > &__os, const sub_match< _Bi_iter > &__m)
template<typename _BiIter >
bool | std::operator<= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator<= (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator<= (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator<= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator<= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator<= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator<= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _BiIter >
bool | std::operator== (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator== (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator== (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator== (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator== (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator== (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator== (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Bi_iter , typename _Alloc >
bool | std::operator== (const match_results< _Bi_iter, _Alloc > &__m1, const match_results< _Bi_iter, _Alloc > &__m2)
template<typename _BiIter >
bool | std::operator> (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator> (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator> (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator> (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator> (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator> (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator> (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _BiIter >
bool | std::operator>= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator>= (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator>= (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator>= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator>= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator>= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator>= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Ch_type , typename _Rx_traits >
void | std::swap (basic_regex< _Ch_type, _Rx_traits > &__lhs, basic_regex< _Ch_type, _Rx_traits > &__rhs)
template<typename _Bi_iter , typename _Alloc >
void | std::swap (match_results< _Bi_iter, _Alloc > &__lhs, match_results< _Bi_iter, _Alloc > &__rhs)
int | std::regex_traits< _Ch_type >::value (_Ch_type __ch, int __radix) const

## Matching, Searching, and Replacing

template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (_Bi_iter __s, _Bi_iter __e, match_results< _Bi_iter, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (_Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_type , typename _Alloc , typename _Rx_traits >
bool | std::regex_match (const _Ch_type *__s, match_results< const _Ch_type *, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > &__s, match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_type , class _Rx_traits >
bool | std::regex_match (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_traits , typename _Str_allocator , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (const basic_string< _Ch_type, _Ch_traits, _Str_allocator > &__s, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (_Bi_iter __first, _Bi_iter __last, match_results< _Bi_iter, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (_Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_type , class _Alloc , class _Rx_traits >
bool | std::regex_search (const _Ch_type *__s, match_results< const _Ch_type *, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_traits , typename _String_allocator , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (const basic_string< _Ch_type, _Ch_traits, _String_allocator > &__s, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > &__s, match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type >
_Out_iter | std::regex_replace (_Out_iter __out, _Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__e, const basic_string< _Ch_type > &__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Rx_traits , typename _Ch_type >
basic_string< _Ch_type > | std::regex_replace (const basic_string< _Ch_type > &__s, const basic_regex< _Ch_type, _Rx_traits > &__e, const basic_string< _Ch_type > &__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)

## Detailed Description

A facility for performing regular expression pattern matching.

## Typedef Documentation

typedef regex_token_iterator<const char*> std::cregex_token_iterator

Token iterator for C-style NULL-terminated strings.

Definition at line 2469 of file regex.h.

typedef sub_match<const char*> std::csub_match

Standard regex submatch over a C-style null-terminated string.

Definition at line 834 of file regex.h.

typedef basic_regex<char> std::regex

Standard regular expressions.

Definition at line 706 of file regex.h.

typedef regex_token_iterator<string::const_iterator> std::sregex_token_iterator

Token iterator for standard strings.

Definition at line 2472 of file regex.h.

typedef sub_match<string::const_iterator> std::ssub_match

Standard regex submatch over a standard string.

Definition at line 837 of file regex.h.

typedef regex_token_iterator<const wchar_t*> std::wcregex_token_iterator

Token iterator for C-style NULL-terminated wide strings.

Definition at line 2476 of file regex.h.

typedef sub_match<const wchar_t*> std::wcsub_match

Regex submatch over a C-style null-terminated wide string.

Definition at line 841 of file regex.h.

typedef basic_regex<wchar_t> std::wregex

Standard wide-character regular expressions.

Definition at line 710 of file regex.h.

typedef regex_token_iterator<wstring::const_iterator> std::wsregex_token_iterator

Token iterator for standard wide-character strings.

Definition at line 2479 of file regex.h.

typedef sub_match<wstring::const_iterator> std::wssub_match

Regex submatch over a standard wide string.

Definition at line 844 of file regex.h.

## Function Documentation

template<typename _Ch_type >

bool std::regex_traits< _Ch_type >::isctype | ( | _Ch_type | __c,
|  | char_class_type | __f
| ) |  | const

Determines if `c` is a member of an identified class.

Parameters

  __c | a character.
  __f | a class type (as returned from lookup_classname).

Returns
  true if the character `__c` is a member of the classification represented by `__f`, false otherwise.

Exceptions

  std::bad_cast | if the current locale does not have a ctype facet.

Definition at line 280 of file regex.h.

template<typename _BiIter >

bool std::operator!= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the inequivalence of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 868 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator!= | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the inequivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 943 of file regex.h.

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the inequivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1017 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the inequivalence of an iterator value and a regular expression submatch.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1091 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the inequivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A pointer to a string.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1165 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the inequivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1242 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the inequivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1322 of file regex.h.

template<typename _Bi_iter , class _Alloc >

bool std::operator!= | ( | const match_results< _Bi_iter, _Alloc > & | __m1,
|  | const match_results< _Bi_iter, _Alloc > & | __m2
| ) |  |

inline

Compares two match_results for inequality.

Returns
  true if the two objects do not refer to the same match, false otherwise.

Definition at line 1834 of file regex.h.

template<typename _BiIter >

bool std::operator< | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 879 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator< | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 955 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1029 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::compare().

template<typename _Bi_iter >

bool std::operator< | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1103 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1177 of file regex.h.

template<typename _Bi_iter >

bool std::operator< | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1254 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1334 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Ch_type , typename _Ch_traits , typename _Bi_iter >

basic_ostream<_Ch_type, _Ch_traits>& std::operator<< | ( | basic_ostream< _Ch_type, _Ch_traits > & | __os,
|  | const sub_match< _Bi_iter > & | __m
| ) |  |

inline

Inserts a matched string into an output stream.

Parameters

  __os | The output stream.
  __m | A submatch string.

Returns
  the output stream with the submatch string inserted.

Definition at line 1388 of file regex.h.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator<= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 890 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator<= | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 991 of file regex.h.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1065 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1139 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1213 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1293 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1373 of file regex.h.

template<typename _BiIter >

bool std::operator== | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the equivalence of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 857 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator== | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the equivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 930 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str(), and std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the equivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1004 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str(), and std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the equivalence of a C string and a regular expression submatch.

Parameters

  __lhs | A C string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1078 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the equivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A pointer to a string?

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1152 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the equivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1226 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the equivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1306 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Alloc >

bool std::operator== | ( | const match_results< _Bi_iter, _Alloc > & | __m1,
|  | const match_results< _Bi_iter, _Alloc > & | __m2
| ) |  |

inline

Compares two match_results for equality.

Returns
  true if the two objects refer to the same match, false otherwise.

Definition at line 1810 of file regex.h.

References std::match_results< _Bi_iter, _Alloc >::begin(), std::match_results< _Bi_iter, _Alloc >::empty(), std::match_results< _Bi_iter, _Alloc >::end(), std::equal(), std::match_results< _Bi_iter, _Alloc >::prefix(), std::match_results< _Bi_iter, _Alloc >::ready(), std::match_results< _Bi_iter, _Alloc >::size(), and std::match_results< _Bi_iter, _Alloc >::suffix().

template<typename _BiIter >

bool std::operator> | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 912 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator> | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 967 of file regex.h.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1041 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1115 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1189 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1269 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1349 of file regex.h.

template<typename _BiIter >

bool std::operator>= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 901 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator>= | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 979 of file regex.h.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1053 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1127 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1201 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1281 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1361 of file regex.h.

template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | _Bi_iter | __s,
|  | _Bi_iter | __e,
|  | match_results< _Bi_iter, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

Determines if there is a match between the regular expression `e` and all of the character sequence [first, last).

Parameters

  __s | Start of the character sequence to match.
  __e | One-past-the-end of the character sequence to match.
  __m | The match results.
  __re | The regular expression.
  __flags | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Todo:
  Implement this function.

Definition at line 1878 of file regex.h.

Referenced by std::regex_match().

template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

Indicates if there is a match between the regular expression `e` and all of the character sequence [first, last).

Parameters

  __first | Beginning of the character sequence to match.
  __last | One-past-the-end of the character sequence to match.
  __re | The regular expression.
  __flags | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 1909 of file regex.h.

References std::regex_match().

template<typename _Ch_type , typename _Alloc , typename _Rx_traits >

bool std::regex_match | ( | const _Ch_type * | __s,
|  | match_results< const _Ch_type *, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Determines if there is a match between the regular expression `e` and a C-style null-terminated string.

Parameters

  __s | The C-style null-terminated string to match.
  __m | The match results.
  __re | The regular expression.
  __f | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 1934 of file regex.h.

References std::regex_match().

template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > & | __s,
|  | match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Determines if there is a match between the regular expression `e` and a string.

Parameters

  __s | The string to match.
  __m | The match results.
  __re | The regular expression.
  __flags | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 1958 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_match().

template<typename _Ch_type , class _Rx_traits >

bool std::regex_match | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Indicates if there is a match between the regular expression `e` and a C-style null-terminated string.

Parameters

  __s | The C-style null-terminated string to match.
  __re | The regular expression.
  __f | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 1981 of file regex.h.

References std::regex_match().

template<typename _Ch_traits , typename _Str_allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | const basic_string< _Ch_type, _Ch_traits, _Str_allocator > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Indicates if there is a match between the regular expression `e` and a string.

Parameters

  __s | [IN] The string to match.
  __re | [IN] The regular expression.
  __flags | [IN] Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 2003 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_match().

template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type >

_Out_iter std::regex_replace | ( | _Out_iter | __out,
|  | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const basic_string< _Ch_type > & | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Todo:
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Parameters

  __out |
  __first |
  __last |
  __e |
  __fmt |
  __flags |

Returns
  out

Exceptions

  an | exception of type regex_error.

Todo:
  Implement this function.

Definition at line 2162 of file regex.h.

Referenced by std::regex_replace().

template<typename _Rx_traits , typename _Ch_type >

basic_string<_Ch_type> std::regex_replace | ( | const basic_string< _Ch_type > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const basic_string< _Ch_type > & | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Todo:
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Parameters

  __s |
  __e |
  __fmt |
  __flags |

Returns
  a copy of string `s` with replacements.

Exceptions

  an | exception of type regex_error.

Definition at line 2182 of file regex.h.

References std::back_inserter(), std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_replace().

template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | match_results< _Bi_iter, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a range.

Parameters

  __first | [IN] The start of the string to search.
  __last | [IN] One-past-the-end of the string to search.
  __m | [OUT] The match results.
  __re | [IN] The regular expression to search for.
  __flags | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string, the content of m is undefined.

Exceptions

  an | exception of type regex_error.

Todo:
  Implement this function.

Definition at line 2028 of file regex.h.

Referenced by std::regex_search().

template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a range.

Parameters

  __first | [IN] The start of the string to search.
  __last | [IN] One-past-the-end of the string to search.
  __re | [IN] The regular expression to search for.
  __flags | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string.

Todo:
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Exceptions

  an | exception of type regex_error.

Definition at line 2049 of file regex.h.

References std::regex_search().

template<typename _Ch_type , class _Alloc , class _Rx_traits >

bool std::regex_search | ( | const _Ch_type * | __s,
|  | match_results< const _Ch_type *, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a C-string.

Parameters

  __s | [IN] A C-string to search for the regex.
  __m | [OUT] The set of regex matches.
  __e | [IN] The regex to search for in `s`.
  __f | [IN] The search flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string, the content of m is undefined.

Todo:
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Exceptions

  an | exception of type regex_error.

Definition at line 2073 of file regex.h.

References std::regex_search().

template<typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a C-string.

Parameters

  __s | [IN] The C-string to search.
  __e | [IN] The regular expression to search for.
  __f | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string.

Todo:
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Exceptions

  an | exception of type regex_error.

Definition at line 2093 of file regex.h.

References std::regex_search().

template<typename _Ch_traits , typename _String_allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const basic_string< _Ch_type, _Ch_traits, _String_allocator > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a string.

Parameters

  __s | [IN] The string to search.
  __e | [IN] The regular expression to search for.
  __flags | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string.

Todo:
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Exceptions

  an | exception of type regex_error.

Definition at line 2113 of file regex.h.

References std::regex_search().

template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > & | __s,
|  | match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a string.

Parameters

  __s | [IN] A C++ string to search for the regex.
  __m | [OUT] The set of regex matches.
  __e | [IN] The regex to search for in `s`.
  __f | [IN] The search flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string, the content of m is undefined.

Exceptions

  an | exception of type regex_error.

Definition at line 2136 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_search().

template<typename _Ch_type , typename _Rx_traits >

void std::swap | ( | basic_regex< _Ch_type, _Rx_traits > & | __lhs,
|  | basic_regex< _Ch_type, _Rx_traits > & | __rhs
| ) |  |

inline

Swaps the contents of two regular expression objects.

Parameters

  __lhs | First regular expression.
  __rhs | Second regular expression.

Definition at line 722 of file regex.h.

References std::basic_regex< _Ch_type, _Rx_traits >::swap().

template<typename _Bi_iter , typename _Alloc >

void std::swap | ( | match_results< _Bi_iter, _Alloc > & | __lhs,
|  | match_results< _Bi_iter, _Alloc > & | __rhs
| ) |  |

inline

Swaps two match results.

Parameters

  __lhs | A match result.
  __rhs | A match result.

The contents of the two match_results objects are swapped.

Definition at line 1848 of file regex.h.

References std::match_results< _Bi_iter, _Alloc >::swap().

template<typename _Ch_type >

int std::regex_traits< _Ch_type >::value | ( | _Ch_type | __ch,
|  | int | __radix
| ) |  | const

Converts a digit to an int.

Parameters

  __ch | a character representing a digit.
  __radix | the radix if the numeric conversion (limited to 8, 10, or 16).

Returns
  the value represented by the digit __ch in base radix if the character __ch is a valid digit in base radix; otherwise returns -1.

Definition at line 314 of file regex.h.

References std::basic_ios< _CharT, _Traits >::fail(), std::hex(), and std::oct().